Index: Utilities.h
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Utilities.h,v
retrieving revision 1.26
diff -u -p -b -r1.26 Utilities.h
--- Utilities.h	2 Dec 2004 22:28:42 -0000	1.26
+++ Utilities.h	10 Apr 2005 22:43:20 -0000
@@ -1,15 +1,16 @@
 /////////////////////////////////////////////////////////////////////
-//  File: Utilities.h
+// $Id: Utilities.h,v 1.33 2005/03/29 18:02:58 klas Exp $
+//
 // Usage: Various functions that doesn't belong anywhere else.
 //
 //  A part of babyftpd, licensed under the GNU GPL, see the file
 //    LICENSE for complete information.
 /////////////////////////////////////////////////////////////////////
 
-#ifndef __UTILITIES_H__
-#define __UTILITIES_H__
+#ifndef UTILITIES_H
+#define UTILITIES_H
 
-#ifdef __UTILITIES_CPP__
+#ifdef UTILITIES_CPP
 #include "generic.h"
 #endif
 
@@ -20,13 +21,12 @@ class Utilities
   public:
     void strip_line_breaks(string&);
     int clean_string(string&);
-    string itos(int);
+    string itos(long long int);
     string parse_perms_ls(mode_t);
     string parse_perms_num(mode_t);
+    int time_string(string&, string, size_t len = 50, time_t timep = 0);
 
     // small inline functions, previously macros
-    bool test(int a, int b)
-    { return((a & b) == b); }
     bool is_set(unsigned int flag, unsigned int bit)
     { return(flag & bit); }
     void set_bit(unsigned int &flag, unsigned int bit)
@@ -35,6 +35,13 @@ class Utilities
     { flag &= ~bit; }
     void toggle_bit(unsigned int &flag, unsigned int bit)
     { flag ^= bit;  }
+    struct eqstr
+    {
+      bool operator()(const char *s1, const char *s2)
+      { return strcmp(s1, s2) == 0; }
+    };
 };
 
+extern class Utilities util;
+
 #endif
Index: babyftpd.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/babyftpd.cpp,v
retrieving revision 1.109
diff -u -p -b -r1.109 babyftpd.cpp
--- babyftpd.cpp	22 Jan 2005 23:06:05 -0000	1.109
+++ babyftpd.cpp	10 Apr 2005 22:43:20 -0000
@@ -1,5 +1,5 @@
 /////////////////////////////////////////////////////////////////////
-//  $Id: babyftpd.cpp,v 1.109 2005/01/22 23:06:05 klas Exp $
+//  $Id: babyftpd.cpp,v 1.129 2005/04/09 12:11:16 klas Exp $
 //
 // Usage: main function, commandline parsing and function that
 //        on the main socket.
@@ -8,8 +8,8 @@
 //    LICENSE for complete information.
 /////////////////////////////////////////////////////////////////////
 
-#define __BABYFTPD_CPP__
-#define __NETINCLS__
+#define BABYFTPD_CPP
+#define NETINCLS
 #include "babyftpd.h"
 
 int main(int argc, char **argv)
@@ -17,15 +17,16 @@ int main(int argc, char **argv)
   pid_t pid;
 
   logging = new class Log;
-  // we want the config object created before we parse commandline as that can set stuff.
   config = new class Configuration;
-  parse_commandline(argc, argv);
+  config->parse_command_line(argc, argv);
   // we send the start message for logging here so that starts our log.
   logging->log_this(3, TYPE_INFO, config->general.welcome_msg + " started.");
   // the config file variable exists in the Configuration class :p
   if(config->parse_config_file() == false)
-    cout << "Failed to open the config file (" << config->conf_file << "), check if it exists + permissions." << endl;
-  
+    cout << "Failed to open the config file (" << config->conf_file <<
+      "), check if it exists + permissions." << endl;
+  // if the conffile changes variables from commandline we reset them.
+  config->parse_command_line(argc, argv);
   
   if(config->general.no_daemon == false)
     pid = fork();
@@ -75,9 +76,11 @@ int main(int argc, char **argv)
       pthread_key_create(&my_data, kill_data);
 
       sem_init(&user_list_lock, 0, 1);
+      sem_init(&cleanup_list_lock, 0, 1);
       sem_init(&comm.pam_lock, 0, 1);
 
       signal(SIGTERM, sig_handler);
+      signal(SIGINT, sig_handler);
       signal(SIGHUP, sig_handler);
       signal(SIGPIPE, sig_handler);
 
@@ -93,15 +96,19 @@ int main(int argc, char **argv)
       gnutls_global_init();
 
       gnutls_certificate_allocate_credentials(&x509_cred);
-      ret = gnutls_certificate_set_x509_trust_file(x509_cred, config->general.tls_ca.c_str(), GNUTLS_X509_FMT_PEM);
+      ret = gnutls_certificate_set_x509_trust_file(x509_cred,
+          config->general.tls_ca.c_str(), GNUTLS_X509_FMT_PEM);
       if(ret < 0)
         logging->log_this(2, TYPE_INFO, gnutls_strerror(ret));
 
-      ret = gnutls_certificate_set_x509_crl_file(x509_cred, config->general.tls_crl.c_str(), GNUTLS_X509_FMT_PEM);
+      ret = gnutls_certificate_set_x509_crl_file(x509_cred,
+          config->general.tls_crl.c_str(), GNUTLS_X509_FMT_PEM);
       if(ret < 0)
         logging->log_this(2, TYPE_INFO, gnutls_strerror(ret));
 
-      ret = gnutls_certificate_set_x509_key_file(x509_cred, config->general.tls_cert.c_str(), config->general.tls_key.c_str(), GNUTLS_X509_FMT_PEM);
+      ret = gnutls_certificate_set_x509_key_file(x509_cred,
+          config->general.tls_cert.c_str(), config->general.tls_key.c_str(),
+          GNUTLS_X509_FMT_PEM);
       if(ret < 0)
         logging->log_this(2, TYPE_INFO, gnutls_strerror(ret));
 
@@ -113,7 +120,7 @@ int main(int argc, char **argv)
       dh_time = time(NULL);
 
 #endif // USE_TLS
-      
+      handler = new Handler;
       listener();
       break;
       
@@ -133,42 +140,48 @@ bool listener(void)
   address.sin_family = AF_INET;
   address.sin_addr.s_addr = INADDR_ANY;
   address.sin_port = htons(config->general.port);
-  if(bind(first_socket, reinterpret_cast<struct sockaddr*>(&address), sizeof(address)) < 0)
+  if(bind(first_socket, reinterpret_cast<struct sockaddr*>(&address),
+        sizeof(address)) < 0)
   {
-    logging->log_this(2, TYPE_INFO, "Port " + util.itos(config->general.port) + " already in use.");
+    logging->log_this(2, TYPE_INFO, "Port " +
+        util.itos(config->general.port) + " already in use.");
     exit_baby(1, EXIT_FULL);
   }
   seteuid(config->general.user);
+  setgid(config->general.group);
   listen(first_socket, LISTEN_LIMIT);
   while(true)
   {
     pthread_t thread_tmp;
     socklen_t socketlen = sizeof(struct sockaddr_in);
     fd_set sock_set;
-    time_t before = time(NULL);
+    time_t before = time(NULL) - (config->general.lifebeat_tick - tv.tv_sec);
 
     FD_ZERO(&sock_set);
     FD_SET(first_socket, &sock_set);
     if(!select(first_socket + 1, &sock_set, NULL, NULL, &tv))
     {
       lifebeat();
-      tv.tv_sec = config->general.lifebeat_tick; // important to reset lifebeat.
+      tv.tv_sec = config->general.lifebeat_tick; // important to reset lifebeat
       continue;
     }
 
-    int final_socket[0];
-    final_socket[0] = accept(first_socket,
+    int *final_socket = new int;
+    *final_socket = accept(first_socket,
         reinterpret_cast<struct sockaddr*>(&address), &socketlen);
-    if(final_socket[0] != -1)
-    {
-      pthread_create(&thread_tmp, NULL, user_wrapper,
-          static_cast<void*>(final_socket));
-      pthread_detach(thread_tmp);
-    }
+    if(*final_socket != -1)
+      pthread_create(&thread_tmp, NULL, user_wrapper, (final_socket));
     else
+    {
       logging->log_this(3, TYPE_INFO, "Failed to accept new caller.");
+      // if the socket is accepted and the thread created the pointer will
+      // get deleted there after it is stored.
+      delete final_socket;
+    }
 
     tv.tv_sec = config->general.lifebeat_tick - (time(NULL) - before);
+    if(tv.tv_sec < 0 || tv.tv_sec > config->general.lifebeat_tick)
+      tv.tv_sec = 0;
   }
   close(first_socket);
 
@@ -179,13 +192,24 @@ void lifebeat(void)
 {
   logging->log_this(4, TYPE_DEBUG, "lifebeat reached.");
 
+  sem_wait(&cleanup_list_lock);
+  while(!cleanup_list.empty())
+  {
+    logging->log_this(4, TYPE_DEBUG, "joining thread #" +
+        util.itos(cleanup_list.back()));
+    pthread_join(cleanup_list.back(), NULL);
+    cleanup_list.pop_back();
+  }
+  sem_post(&cleanup_list_lock);
+
 #ifdef USE_TLS
   if((time(NULL) - dh_time) > config->general.dh_regenerate)
   {
     gnutls_dh_params temp_dh_params;
     gnutls_dh_params_init(&temp_dh_params);
     gnutls_dh_params_generate2(temp_dh_params, 1024);
-    dh_params = temp_dh_params;
+    gnutls_dh_params_cpy(dh_params, temp_dh_params);
+    gnutls_dh_params_deinit(temp_dh_params);
     gnutls_certificate_set_dh_params(x509_cred, dh_params);
     dh_time = time(NULL);
   }
@@ -196,12 +220,14 @@ static void *user_wrapper(void *socket_i
 {
   pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, NULL);
 
-  class User *user = handler.initializer(static_cast<int>((static_cast<int*>(socket_id)[0])));
+  class User *user = handler->initializer((*(static_cast<int*>(socket_id))));
+  delete (static_cast<int*>(socket_id));
   pthread_setspecific(my_user, static_cast<void*>(user));
 
-  handler.init(user);
+  handler->init(user);
 
-  logging->log_this(3, TYPE_DEBUG, "closed connection from: " + user->host_name);
+  logging->log_this(3, TYPE_DEBUG, "closed connection from: " +
+      user->host_name());
   pthread_exit(NULL); // the thread exits..., and takes the user with it..
 }
 
@@ -213,150 +239,21 @@ static void *log_wrapper(void *not_used)
   pthread_exit(NULL);
 }
 
-void parse_commandline(int argc, char **argv)
-{
-  int opt = 0;
-  const char *cmdopts = "hvc:nVl:qp:";
-  bool help, verbose, conf_file, no_daemon, version, quiet, port;
-  help = verbose = conf_file = no_daemon = version = quiet = port = false;
-   
-  // struct for the long options... neat, huh?
-  struct option longopts[] =
-  {
-    { "help",      0, 0, 'h' },
-    { "verbose",   0, 0, 'v' },
-    { "conf-file", 1, 0, 'c' },
-    { "no-daemon", 0, 0, 'd' },
-    { "version",   0, 0, 'V' },
-    { "log-level", 1, 0, 'l' },
-    { "quiet",     0, 0, 'q' },
-    { "port",      1, 0, 'p' },
-    { 0,           0, 0, 0   }
-  };
-  
-  while((opt = getopt_long(argc, argv, cmdopts, longopts, NULL)) != -1)
-  {
-    switch(opt)
-    {
-      case 'h':
-        // help code
-        help = true;
-        break;
-
-      case 'v':
-        // verbosity code
-        // FIXME implement this throughout the code
-        verbose = true;
-        config->general.verbose++;
-        break;
-
-      case 'c':
-        // alternate conf file code
-        conf_file = true;
-        config->conf_file = optarg;
-        break;
-
-      case 'n':
-        // no-daemon code
-        no_daemon = true;
-        config->general.no_daemon = true;
-        break;
-
-      case 'V':
-        // Version code
-        version = true;
-        break;
-
-      case 'l':
-        // Log level code...
-        int log_level;
-        if(atoi(optarg) > 10)
-          log_level = 10;
-        else if(atoi(optarg) < 0)
-          log_level = 0;
-        else
-          log_level = atoi(optarg);
-        config->logger.log_level = log_level;
-        break;
-
-      case 'q':
-        // shh... quiet...
-        // FIXME implement this throughout the code
-        quiet = true;
-        config->general.verbose--;
-        break;
-
-      case 'p':
-        // alternate port...
-        // FIXME this should disable port argument from conffile...
-        port = true;
-        config->general.port = atoi(optarg);
-        break;
-        
-      case '?':
-        // unknown option...
-        break;
-        
-      case ':':
-        // missing parameter...
-        break;
-        
-      default:
-        // shouldn't get here...
-        cout << "Hey... you got waaay off track somewhere above :p" << endl;
-        break;
-    }
-
-    if(help == true)
-    { 
-      cout << "Usage: " << argv[0] << " [OPTION]..." << endl;
-      cout << endl;
-      cout << "  -h, --help            display this help and exit" << endl;
-      cout << "  -v, --verbose         increase verbosity(*)" << endl;
-      cout << "  -c, --conf-file=FILE  supply another conf file instead of the default" << endl;
-      cout << "  -n, --no-daemon       do not fork into the background" << endl;
-      cout << "  -V, --version         display version information and exit" << endl;
-      cout << "  -l, --log-level=LEVEL set the log level, 1-10, default is 5" << endl;
-      cout << "  -q, --quiet           decrease verbosity(*)" << endl;
-      cout << "  -p, --port=PORT       specify an alternate port" << endl;
-      cout << endl;
-      cout << "    (*) only hooks for these options in yet, doesn't really work." << endl;
-      cout << endl;
-      cout << "Please, report bugs, either directly to the developers" << endl;
-      cout << "or via sourceforge (http://www.sf.net/projects/babyftpd)." << endl;
-
-      exit_baby(0, EXIT_EARLY);
-    }
-    
-    if(version == true)
-    {
-      string version_info;
-      // we're building the version string here... again, smallest possible scope...
-      version_info = "BabyFTPd version ";
-      version_info += VERSION;
-      version_info += "\nBuilt on ";
-      version_info += __DATE__;
-      version_info += " ";
-      version_info += __TIME__;
-      version_info += "\n";
-      
-      cout << version_info;
-      exit_baby(0, EXIT_EARLY);
-    }
-  }
-}
 
 void sig_handler(int signal)
 {
   switch(signal)
   {
     case SIGTERM:
+    case SIGINT:
       logging->log_this(3, TYPE_INFO, "SIGTERM received.");
 
-      logging->log_this(4, TYPE_DEBUG, "main thread. users: " + util.itos(user_list.size()));
+      logging->log_this(4, TYPE_DEBUG, "main thread. users: " +
+          util.itos(user_list.size()));
 
-      for(vector<User*>::iterator user_it = user_list.begin(); user_it != user_list.end(); user_it++)
-        pthread_cancel((*user_it)->thread_id);
+      for(vector<User*>::iterator user_it = user_list.begin();
+          user_it != user_list.end(); user_it++)
+        pthread_cancel((*user_it)->thread_id());
 
       struct timeval times;
       times.tv_sec = 1;
@@ -385,15 +282,26 @@ void sig_handler(int signal)
 
 void exit_baby(int num, int how)
 {
+  sem_wait(&cleanup_list_lock);
+  while(!cleanup_list.empty())
+  {
+    logging->log_this(4, TYPE_DEBUG, "joining thread #" +
+        util.itos(cleanup_list.back()));
+    pthread_join(cleanup_list.back(), NULL);
+    cleanup_list.pop_back();
+  }
+  sem_post(&cleanup_list_lock);
 
   if(how == EXIT_FULL)
   {
+    delete handler;
     pthread_key_delete(my_user);
     pthread_key_delete(my_data);
 
 #ifdef USE_TLS
     // emptying and freeing session cache.
-    for(vector<cache*>::iterator cache_it = cache_db.begin(); cache_it != cache_db.end(); cache_it++)
+    for(vector<cache*>::iterator cache_it = cache_db.begin();
+        cache_it != cache_db.end(); cache_it++)
     {
       gnutls_free((*cache_it)->key.data);
       gnutls_free((*cache_it)->data.data);
@@ -407,11 +315,12 @@ void exit_baby(int num, int how)
     sem_destroy(&cache_lock);
 #endif // USE_TLS 
     sem_destroy(&comm.pam_lock);
+    sem_destroy(&cleanup_list_lock);
     sem_destroy(&user_list_lock);
     pthread_cancel(logging_thread);
     pthread_join(logging_thread, NULL);
   }
-  delete(logging);
+  delete logging;
 
   delete config;
   exit(num);
@@ -427,7 +336,8 @@ int tls_db_store(void *dbf, gnutls_datum
   temp_cache->key.size = key.size;
   memcpy(temp_cache->key.data, key.data, key.size);
 
-  temp_cache->data.data = static_cast<unsigned char*>(gnutls_malloc(data.size));
+  temp_cache->data.data =
+    static_cast<unsigned char*>(gnutls_malloc(data.size));
   temp_cache->data.size = data.size;
   memcpy(temp_cache->data.data, data.data, data.size);
 
@@ -441,7 +351,8 @@ gnutls_datum tls_db_fetch(void *dbf, gnu
 {
   gnutls_datum data = { NULL, 0 };
 
-  for(vector<cache*>::iterator cache_it = cache_db.begin(); cache_it != cache_db.end(); cache_it++)
+  for(vector<cache*>::iterator cache_it = cache_db.begin();
+      cache_it != cache_db.end(); cache_it++)
     if(memcmp(key.data, (*cache_it)->key.data, (*cache_it)->key.size) == 0)
     {
       data.size = (*cache_it)->data.size;
@@ -455,7 +366,8 @@ gnutls_datum tls_db_fetch(void *dbf, gnu
 
 int tls_db_delete(void *dbf, gnutls_datum key)
 {
-  for(vector<cache*>::iterator cache_it = cache_db.begin(); cache_it != cache_db.end(); cache_it++)
+  for(vector<cache*>::iterator cache_it = cache_db.begin();
+      cache_it != cache_db.end(); cache_it++)
     if(memcmp(key.data, (*cache_it)->key.data, (*cache_it)->key.size) == 0)
     {
       sem_wait(&cache_lock);
Index: babyftpd.h
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/babyftpd.h,v
retrieving revision 1.47
diff -u -p -b -r1.47 babyftpd.h
--- babyftpd.h	18 Jan 2005 22:44:36 -0000	1.47
+++ babyftpd.h	10 Apr 2005 22:43:20 -0000
@@ -1,5 +1,5 @@
 /////////////////////////////////////////////////////////////////////
-// $Id: babyftpd.h,v 1.47 2005/01/18 22:44:36 klas Exp $
+// $Id: babyftpd.h,v 1.54 2005/03/28 17:08:12 klas Exp $
 //
 // Usage: main function, commandline parsing and function that
 //        on the main socket.
@@ -8,21 +8,23 @@
 //    LICENSE for complete information.
 /////////////////////////////////////////////////////////////////////
 
-#ifndef __BABYFTPD_H__
-#define __BABYFTPD_H__
+#ifndef BABYFTPD_H
+#define BABYFTPD_H
 
-#ifdef __BABYFTPD_CPP__
+#ifdef BABYFTPD_CPP
 #include "generic.h"
+#include "Utilities.h"
 #include "Configuration.h"
+#include "Log.h"
+#include "Connection.h"
 #include "User.h"
+#include "Data.h"
 #include "Handler.h"
 #include "Commands.h"
-#include "Utilities.h"
-#include "Log.h"
 #ifdef USE_TLS
 #include "tls.cpp"
 #endif // USE_TLS
-#endif // __BABYFTPD_CPP__
+#endif // BABYFTPD_CPP
 
 static void *user_wrapper(void*) __attribute__ ((noreturn));
 static void *log_wrapper(void*) __attribute__ ((noreturn));
@@ -32,26 +34,18 @@ void sig_handler(int);
 void exit_baby(int, int);
 void lifebeat(void);
 
-class Configuration *config;
-class Handler handler;
-class Commands comm;
-class Utilities util;
-class Log *logging;
-
 // thread specific storage..
 pthread_key_t my_user = 0;
 pthread_key_t my_data = 0;
 
 sem_t user_list_lock;
+sem_t cleanup_list_lock;
 pthread_t main_thread; // for managing on shutdown and signal handling.
 pthread_t logging_thread; // so we can join it.
 vector<User*> user_list;
+vector<pthread_t> cleanup_list;
 
-#define LISTEN_LIMIT 5
-
-// for exit_baby()
-#define EXIT_EARLY 1
-#define EXIT_FULL  2
+const int LISTEN_LIMIT = 5;
 
 #ifdef USE_TLS
 gnutls_certificate_credentials x509_cred;
Index: commands.hlp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/commands.hlp,v
retrieving revision 1.4
diff -u -p -b -r1.4 commands.hlp
--- commands.hlp	10 Jul 2004 17:22:27 -0000	1.4
+++ commands.hlp	10 Apr 2005 22:43:20 -0000
@@ -1,40 +1,40 @@
-#define HLP_USER " <username> (send username)"
-#define HLP_PASS " <password> (send password)" 
-#define HLP_RETR " <file> (sends a file over a data connection)"
-#define HLP_STOR " <file> (receives a file over a data connection)"
-#define HLP_PORT " <a1,a2,a3,a4,p1,p2> (specify client data port)"
-#define HLP_EPRT " <|protocol|adress|port|> (specify client data adress and port)"
-#define HLP_QUIT " (logout)"
-#define HLP_LIST " <path> (lists a directory or file(s))"
-#define HLP_TYPE " <type> (sets the transfer type for future transfers)"
-#define HLP_HELP " [<command> (returns help for specified command)] (shows available commands)"
-#define HLP_SYST " (returns the system type)"
-#define HLP_NOOP " (no operation)"
-#define HLP_DELE " <file> (delete file)"
-#define HLP_NLST " <path> (lists only names of a directory or file(s))"
-#define HLP_PASV " (returns a non standard data port for transfers)"
-#define HLP_EPSV " (returns a non standard data port (extended format) for transfers)"
-#define HLP_REST " <integer> (Sets the file pointer for the next RETR/STOR command to <value> (bytes))"
-#define HLP_APPE " <file> (appends to file over data connection)"
-#define HLP_RNFR " <file> (given before RNTO, filename to rename from, must be followed by RNTO)"
-#define HLP_RNTO " <file> (given after RNFR, filename to rename to, can only be used after RNFR)"
-#define HLP_SIZE " <file> (returns the exact number of octets <file> occupies)"
-#define HLP_MDTM " <file> (returns modification time of <file>)"
-#define HLP_FEAT " (returns available extensions)"
-#define HLP_MLST " <file> (returns file info for machine parsing)"
-#define HLP_MLSD " <dir> (returns file listing for machine parsing)"
-#define HLP_OPTS " [<command> <options> (modifies options for specified command)] shows what commands options are available for)"
-#define HLP_MODE " <mode> (Set the transfer mode, only accepts S and Z)"
-#define HLP_STRU " <file structure> (OBSOLETE, only accepts F (file))"
-#define HLP_PWD  " (returns current working directory)"
-#define HLP_MKD  " <dir> (creates directory)"
-#define HLP_CDUP " (changes current working directory to parent directory)"
-#define HLP_RMD  " <dir> (removes directory)"
-#define HLP_CWD  " <path> (changes current working directory)"
-#define HLP_FEAT " (returns available extensions)"
+const char *HLP_USER = " <username> (send username)";
+const char *HLP_PASS = " <password> (send password)" ;
+const char *HLP_RETR = " <file> (sends a file over a data connection)";
+const char *HLP_STOR = " <file> (receives a file over a data connection)";
+const char *HLP_PORT = " <a1,a2,a3,a4,p1,p2> (specify client data port)";
+const char *HLP_EPRT = " <|protocol|adress|port|> (specify client data adress and port)";
+const char *HLP_QUIT = " (logout)";
+const char *HLP_LIST = " <path> (lists a directory or file(s))";
+const char *HLP_TYPE = " <type> (sets the transfer type for future transfers)";
+const char *HLP_HELP = " [<command> (returns help for specified command)] (shows available commands)";
+const char *HLP_SYST = " (returns the system type)";
+const char *HLP_NOOP = " (no operation)";
+const char *HLP_DELE = " <file> (delete file)";
+const char *HLP_NLST = " <path> (lists only names of a directory or file(s))";
+const char *HLP_PASV = " (returns a non standard data port for transfers)";
+const char *HLP_EPSV = " (returns a non standard data port (extended format) for transfers)";
+const char *HLP_REST = " <integer> (Sets the file pointer for the next RETR/STOR command to <value> (bytes))";
+const char *HLP_APPE = " <file> (appends to file over data connection)";
+const char *HLP_RNFR = " <file> (given before RNTO, filename to rename from, must be followed by RNTO)";
+const char *HLP_RNTO = " <file> (given after RNFR, filename to rename to, can only be used after RNFR)";
+const char *HLP_SIZE = " <file> (returns the exact number of octets <file> occupies)";
+const char *HLP_MDTM = " <file> (returns modification time of <file>)";
+const char *HLP_FEAT = " (returns available extensions)";
+const char *HLP_MLST = " <file> (returns file info for machine parsing)";
+const char *HLP_MLSD = " <dir> (returns file listing for machine parsing)";
+const char *HLP_OPTS = " [<command> <options> (modifies options for specified command)] shows what commands options are available for)";
+const char *HLP_MODE = " <mode> (Set the transfer mode, only accepts S and Z)";
+const char *HLP_STRU = " <file structure> (OBSOLETE, only accepts F (file))";
+const char *HLP_PWD  = " (returns current working directory)";
+const char *HLP_MKD  = " <dir> (creates directory)";
+const char *HLP_CDUP = " (changes current working directory to parent directory)";
+const char *HLP_RMD  = " <dir> (removes directory)";
+const char *HLP_CWD  = " <path> (changes current working directory)";
+const char *HLP_ABOR = " (cancels any ongoing data transfers)";
 #ifdef USE_TLS
-#define HLP_AUTH " <mechanism> (initiates security mechanism)"
-#define HLP_PBSZ " <integer> (negotiates protection buffer size, 0 for stream)"
-#define HLP_PROT " <prot level> (sets protection level for data channel (P|S|E|C))"
-#define HLP_CCC " (sets protection level of command channel to CLEAR)"
+const char *HLP_AUTH = " <mechanism> (initiates security mechanism)";
+const char *HLP_PBSZ = " <integer> (negotiates protection buffer size, 0 for stream)";
+const char *HLP_PROT = " <prot level> (sets protection level for data channel (P|S|E|C))";
+const char *HLP_CCC = " (sets protection level of command channel to CLEAR)";
 #endif // USE_TLS
Index: config.h.in
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/config.h.in,v
retrieving revision 1.11
diff -u -p -b -r1.11 config.h.in
--- config.h.in	18 Jan 2005 22:57:04 -0000	1.11
+++ config.h.in	10 Apr 2005 22:43:20 -0000
@@ -1,5 +1,10 @@
 /* config.h.in.  Generated from configure.in by autoheader.  */
-/* $Id: config.h.in,v 1.11 2005/01/18 22:57:04 klas Exp $ */
+
+/* Define to 1 if the `closedir' function returns void instead of `int'. */
+#undef CLOSEDIR_VOID
+
+/* Define to 1 if you have the <arpa/inet.h> header file. */
+#undef HAVE_ARPA_INET_H
 
 /* Define to 1 if you have the <dirent.h> header file, and it defines `DIR'.
    */
@@ -8,6 +13,15 @@
 /* Define to 1 if you have the <fcntl.h> header file. */
 #undef HAVE_FCNTL_H
 
+/* Define to 1 if you have the `fork' function. */
+#undef HAVE_FORK
+
+/* Define to 1 if you have the `gethostname' function. */
+#undef HAVE_GETHOSTNAME
+
+/* Define to 1 if you have the `inet_ntoa' function. */
+#undef HAVE_INET_NTOA
+
 /* Define to 1 if you have the <inttypes.h> header file. */
 #undef HAVE_INTTYPES_H
 
@@ -17,24 +31,69 @@
 /* Define to 1 if you have the `pthread' library (-lpthread). */
 #undef HAVE_LIBPTHREAD
 
+/* Define to 1 if you have the `localtime_r' function. */
+#undef HAVE_LOCALTIME_R
+
+/* Define to 1 if `lstat' has the bug that it succeeds when given the
+   zero-length file name argument. */
+#undef HAVE_LSTAT_EMPTY_STRING_BUG
+
+/* Define to 1 if your system has a GNU libc compatible `malloc' function, and
+   to 0 otherwise. */
+#undef HAVE_MALLOC
+
 /* Define to 1 if you have the <memory.h> header file. */
 #undef HAVE_MEMORY_H
 
+/* Define to 1 if you have the `memset' function. */
+#undef HAVE_MEMSET
+
+/* Define to 1 if you have the `mkdir' function. */
+#undef HAVE_MKDIR
+
 /* Define to 1 if you have the <ndir.h> header file, and it defines `DIR'. */
 #undef HAVE_NDIR_H
 
+/* Define to 1 if you have the `rmdir' function. */
+#undef HAVE_RMDIR
+
+/* Define to 1 if you have the <security/pam_appl.h> header file. */
+#undef HAVE_SECURITY_PAM_APPL_H
+
+/* Define to 1 if you have the `select' function. */
+#undef HAVE_SELECT
+
+/* Define to 1 if you have the `socket' function. */
+#undef HAVE_SOCKET
+
+/* Define to 1 if `stat' has the bug that it succeeds when given the
+   zero-length file name argument. */
+#undef HAVE_STAT_EMPTY_STRING_BUG
+
+/* Define to 1 if stdbool.h conforms to C99. */
+#undef HAVE_STDBOOL_H
+
 /* Define to 1 if you have the <stdint.h> header file. */
 #undef HAVE_STDINT_H
 
 /* Define to 1 if you have the <stdlib.h> header file. */
 #undef HAVE_STDLIB_H
 
+/* Define to 1 if you have the `strftime' function. */
+#undef HAVE_STRFTIME
+
 /* Define to 1 if you have the <strings.h> header file. */
 #undef HAVE_STRINGS_H
 
 /* Define to 1 if you have the <string.h> header file. */
 #undef HAVE_STRING_H
 
+/* Define to 1 if you have the `strndup' function. */
+#undef HAVE_STRNDUP
+
+/* Define to 1 if you have the `strtoul' function. */
+#undef HAVE_STRTOUL
+
 /* Define to 1 if you have the <syslog.h> header file. */
 #undef HAVE_SYSLOG_H
 
@@ -46,6 +105,12 @@
    */
 #undef HAVE_SYS_NDIR_H
 
+/* Define to 1 if you have the <sys/select.h> header file. */
+#undef HAVE_SYS_SELECT_H
+
+/* Define to 1 if you have the <sys/socket.h> header file. */
+#undef HAVE_SYS_SOCKET_H
+
 /* Define to 1 if you have the <sys/stat.h> header file. */
 #undef HAVE_SYS_STAT_H
 
@@ -58,6 +123,40 @@
 /* Define to 1 if you have the <unistd.h> header file. */
 #undef HAVE_UNISTD_H
 
+/* Define to 1 if you have the `vfork' function. */
+#undef HAVE_VFORK
+
+/* Define to 1 if you have the <vfork.h> header file. */
+#undef HAVE_VFORK_H
+
+/* Define to 1 if `fork' works. */
+#undef HAVE_WORKING_FORK
+
+/* Define to 1 if `vfork' works. */
+#undef HAVE_WORKING_VFORK
+
+/* Define to 1 if the system has the type `_Bool'. */
+#undef HAVE__BOOL
+
+/* Define to 1 if `lstat' dereferences a symlink specified with a trailing
+   slash. */
+#undef LSTAT_FOLLOWS_SLASHED_SYMLINK
+
+/* Define to mark libgcrypt being 1.1.92 or older */
+#undef OLD_GCRYPT
+
+/* Define as the return type of signal handlers (`int' or `void'). */
+#undef RETSIGTYPE
+
+/* Define to the type of arg 1 for `select'. */
+#undef SELECT_TYPE_ARG1
+
+/* Define to the type of args 2, 3 and 4 for `select'. */
+#undef SELECT_TYPE_ARG234
+
+/* Define to the type of arg 5 for `select'. */
+#undef SELECT_TYPE_ARG5
+
 /* Define to 1 if the `S_IS*' macros in <sys/stat.h> do not work properly. */
 #undef STAT_MACROS_BROKEN
 
@@ -67,20 +166,44 @@
 /* Define to 1 if you can safely include both <sys/time.h> and <time.h>. */
 #undef TIME_WITH_SYS_TIME
 
+/* Define to 1 if your <sys/time.h> declares `struct tm'. */
+#undef TM_IN_SYS_TIME
+
+/* newls enable */
+#undef USE_NEWLS
+
+/* tls enable */
+#undef USE_TLS
+
+/* Define to empty if `const' does not conform to ANSI C. */
+#undef const
+
 /* Define to `int' if <sys/types.h> doesn't define. */
 #undef gid_t
 
+/* Define to `__inline__' or `__inline' if that's what the C compiler
+   calls it, or to nothing if 'inline' is not supported under any name.  */
+#ifndef __cplusplus
+#undef inline
+#endif
+
+/* Define to rpl_malloc if the replacement function should be used. */
+#undef malloc
+
+/* Define to `int' if <sys/types.h> does not define. */
+#undef mode_t
+
+/* Define to `long' if <sys/types.h> does not define. */
+#undef off_t
+
+/* Define to `int' if <sys/types.h> does not define. */
+#undef pid_t
+
 /* Define to `unsigned' if <sys/types.h> does not define. */
 #undef size_t
 
 /* Define to `int' if <sys/types.h> doesn't define. */
 #undef uid_t
 
-/* Define to use TLS */
-#undef USE_TLS
-
-/* Define to mark libgcrypt being 1.1.92 or older */
-#undef OLD_GCRYPT
-
-/* Define to use new format for list */
-#undef USE_NEWLS
+/* Define as `fork' if `vfork' does not work. */
+#undef vfork
